import AppClass from '../../../lib/src/lifecycle/AppClass.ts'
import {Logging} from '../../../lib/src/service/logging/Logging.ts'

export abstract class Directive extends AppClass {
    public abstract readonly keyword: string
    public abstract readonly help: string

    static options() {
        return []
    }

    public abstract invoke(): any

    success(message: any) {
        this.make(Logging).success(message, true)
    }

    error(message: any) {
        this.make(Logging).error(message, true)
    }

    warn(message: any) {
        this.make(Logging).warn(message, true)
    }

    info(message: any) {
        this.make(Logging).info(message, true)
    }

    debug(message: any) {
        this.make(Logging).debug(message, true)
    }

    verbose(message: any) {
        this.make(Logging).verbose(message, true)
    }
}
