import ResponseFactory from './ResponseFactory.ts'
import {Request} from '../Request.ts'

/**
 * Response factory that writes a string as HTML.
 * @extends ResponseFactory
 */
export default class HTMLResponseFactory extends ResponseFactory {
    constructor(
        public readonly value: string,
    ) {
        super()
    }

    public async write(request: Request): Promise<Request> {
        request = await super.write(request)
        request.response.headers.set('Content-Type', 'text/html; charset=utf-8')
        request.response.body = this.value
        return request
    }
}
