import {CookieJar} from '../CookieJar.ts'

/**
 * Base type for an outgoing HTTP response.
 */
export interface HTTPResponse {
    status: number
    headers: Headers
    body: Uint8Array | Deno.Reader | string
    trailers?: () => Promise<Headers> | Headers
    sent: boolean
    cookies: CookieJar,

    send: () => void
}
